moGC_FactorysConfig = {};

function moGC_FactorysConfig:onStartMission()
	moGC_Factorys:load();
end;

function moGC_FactorysConfig:defaultValues()
	moGC_Factorys.values = {factorys={}, updateTimer=5, msec=false};
end;

function moGC_FactorysConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex)
	if moGC_Factorys.values == nil then moGC_FactorysConfig:defaultValues();end;
	local groupNameTag = (xmlNameTag.. ".module.gc_factorys(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
		moGC_Factorys.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	end;
	if getXMLInt(Xml, groupNameTag.. "#updateTimer") then
		moGC_Factorys.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	end;	
end;

function moGC_FactorysConfig:saveXml(self, Xml, xmlNameTag)
	if moGC_Factorys.values == nil then moGC_FactorysConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.gc_factorys(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#updateTimer", moGC_Factorys.values.updateTimer);
	setXMLBool(Xml, groupNameTag.. "#mSecTimer", moGC_Factorys.values.msec);
	----------------------------------------------------------------------------------------------	
end;

function moGC_FactorysConfig.onSaveCallback()
	moSetGetClientSettings:saveConfig(self);
end;