moObjectStoragesConfig = {};

function moObjectStoragesConfig:onStartMission()	
	moObjectStorages:loadObjectStorages();
end;

function moObjectStoragesConfig:defaultValues()
	moObjectStorages.values = {storages={}, updateTimer=20, msec=false};
end;

function moObjectStoragesConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex)
	if moObjectStorages.values == nil then moObjectStoragesConfig:defaultValues();end;
	local groupNameTag = (xmlNameTag.. ".module.objectStorages(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
		moObjectStorages.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	end;
	if getXMLInt(Xml, groupNameTag.. "#updateTimer") then
		moObjectStorages.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	end;
end;

function moObjectStoragesConfig:saveXml(self, Xml, xmlNameTag)
	if moObjectStorages.values == nil then moObjectStoragesConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.objectStorages(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#updateTimer", moObjectStorages.values.updateTimer);
	setXMLBool(Xml, groupNameTag.. "#mSecTimer", moObjectStorages.values.msec);
	----------------------------------------------------------------------------------------------	
end;

function moObjectStoragesConfig.onSaveCallback()
	moSetGetClientSettings:saveConfig(self)
end;