bunkersilos = {};

--needs module bunkersilos
--lineType 2/bunkersilos
function bunkersilos:load(bunkersiloName)	
	local lineTable = {lineTyp=2, txtScroll={leftRight=true,upDown=true}};
	if moBunkerSilos.values.bunkersilos ~= nil and moBunkerSilos.values.bunkersilos[bunkersiloName] ~= nil then
		for bunkersilo=1, #moBunkerSilos.values.bunkersilos[bunkersiloName] do
			if moBunkerSilos.values.bunkersilos[bunkersiloName][bunkersilo] ~= nil then
				local bunkerGeneral = moBunkerSilos.values.bunkersilos[bunkersiloName][bunkersilo].general[1];
				lineTable[#lineTable+1] = {};
				local isLineTable = lineTable[#lineTable];			
				
				if #moBunkerSilos.values.bunkersilos[bunkersiloName] > 1 and bunkersilo ~= 1 then					
					isLineTable.setLineBorderNewObject = true;	
				end;
				
				isLineTable.lineClickHelp = true;
				isLineTable.lineClickHelpCallback = bunkersilos.returnLineHelpIconClick
				isLineTable.helpTxt = "Click BunkerSilo/%/Fermenting or .... ++ for more info (or MapHotSpot)";
				
				isLineTable.ownValues = {bunkersiloName};
				isLineTable.txt = {};			
				isLineTable.txt[1] = {};			
				isLineTable.txt[1].nodeId = bunkerGeneral.object.nodeId;
				isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
				isLineTable.txt[1].bold = true;				
				local isNearObject = moModule:nearPlayerPosition(bunkerGeneral.object, 30);				
				if isNearObject ~= nil then	isLineTable.txt[1].clickCallback = bunkersilos.returnClickObjectName;end;				
				if isNearObject ~= nil and isNearObject then
					isLineTable.txt[1].txt = ">>".. bunkerGeneral.objectName.. "<<";
				else
					isLineTable.txt[1].txt = bunkerGeneral.objectName;
				end;
				isLineTable.txt[1].txtPos = 1;
				---
				local bunkerSilos = moBunkerSilos.values.bunkersilos[bunkersiloName][bunkersilo].bunkerSilos;
				if bunkerSilos ~= nil and #bunkerSilos > 0 then
					for bunkerIndex=1, #bunkerSilos do
						local bunkerGeneral = moBunkerSilos.values.bunkersilos[bunkersiloName][bunkersilo].bunkerSilos[bunkerIndex].general[1];						
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];
						isLineTable.lineClickHelp = true;
						isLineTable.lineClickHelpCallback = bunkersilos.returnLineHelpIconClick
						isLineTable.helpTxt = "Click BunkerSilo/%/Fermenting or .... ++ for more info (or MapHotSpot)";
						
						isLineTable.ownValues = {bunkersiloName};
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};			
						isLineTable.txt[1].nodeId = bunkerGeneral.object.nodeId;
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
						isLineTable.txt[1].bold = true;				
						local isNearObject = moModule:nearPlayerPosition(bunkerGeneral.object, 50);				
						if isNearObject ~= nil then	isLineTable.txt[1].clickCallback = bunkersilos.returnClickObjectName;end;				
						if isNearObject ~= nil and isNearObject then
							isLineTable.txt[1].txt = ">>".. bunkerGeneral.objectName.. "<<";
						else
							isLineTable.txt[1].txt = bunkerGeneral.objectName;
						end;
						--isLineTable.txt[1].txtPos = 1;
						
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];
						isLineTable.ownValues = {bunkersiloName};
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};
						isLineTable.txt[1].width = 80;	--width prozent
						local color = moModule.values.txtColor;
						if bunkerGeneral.fermentingColor ~= nil then color = Utils.getNoNil(moColors.prozent[bunkerGeneral.fermentingColor], 1);end;
						isLineTable.txt[1].color = moColors:getColor(color, nil, moModule.values.txtColor);
						isLineTable.txt[1].bold = moModule.values.txtBold;
						isLineTable.txt[1].txt = moLanguageXml:getTxt("bunkerfermenting", nil, "Ferment");
						isLineTable.txt[2] = {};			
						isLineTable.txt[2].width = 20;	--width prozent						
						isLineTable.txt[2].color = moColors:getColor(color, nil, moModule.values.txtColor)
						isLineTable.txt[2].bold = moModule.values.txtBold;					
						isLineTable.txt[2].txt = bunkerGeneral.fermentingPercent.. "%";
						isLineTable.txt[2].txtPos = 2;
						
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];
						isLineTable.ownValues = {bunkersiloName};
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};
						isLineTable.txt[1].width = 80;	--width prozent
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor);
						isLineTable.txt[1].bold = moModule.values.txtBold;
						isLineTable.txt[1].txt = moLanguageXml:getTxt("bunkercompact", nil, "Compression");
						isLineTable.txt[2] = {};			
						isLineTable.txt[2].width = 20;	--width prozent
						isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
						isLineTable.txt[2].bold = moModule.values.txtBold;					
						isLineTable.txt[2].txt = bunkerGeneral.compactedPercent.. "%";
						isLineTable.txt[2].txtPos = 2;
						
						lineTable[#lineTable+1] = {};
						isLineTable = lineTable[#lineTable];
						isLineTable.ownValues = {bunkersiloName};
						isLineTable.txt = {};			
						isLineTable.txt[1] = {};
						isLineTable.txt[1].width = 80;	--width prozent
						isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor);
						isLineTable.txt[1].bold = moModule.values.txtBold;
						isLineTable.txt[1].txt = moLanguageXml:getTxt("bunkercompactfilllevel", nil, "CompactFill");
						isLineTable.txt[2] = {};			
						isLineTable.txt[2].width = 20;	--width prozent
						isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
						isLineTable.txt[2].bold = moModule.values.txtBold;					
						isLineTable.txt[2].txt = bunkerGeneral.compactedFillLevel;
						isLineTable.txt[2].txtPos = 2;
						
						local bunkerOutput = moBunkerSilos.values.bunkersilos[bunkersiloName][bunkersilo].bunkerSilos[bunkerIndex].output;
						if bunkerOutput ~= nil and #bunkerOutput > 0 then
							local outputTable = bunkerOutput[1];
							lineTable[#lineTable+1] = {};
							isLineTable = lineTable[#lineTable];
							isLineTable.ownValues = {bunkersiloName};
							isLineTable.txt = {};			
							isLineTable.txt[1] = {};			
							isLineTable.txt[1].width = 80;	--width prozent
							isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor)
							isLineTable.txt[1].bold = moModule.values.txtBold;
							isLineTable.txt[1].txt = outputTable.fillTypeName;
							isLineTable.txt[2] = {};			
							isLineTable.txt[2].width = 20;	--width prozent
							isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
							isLineTable.txt[2].bold = moModule.values.txtBold;
							isLineTable.txt[2].txt = outputTable.fillLevel;
							isLineTable.txt[2].txtPos = 2;
						end;
						local bunkerInput = moBunkerSilos.values.bunkersilos[bunkersiloName][bunkersilo].bunkerSilos[bunkerIndex].input;
						if bunkerInput ~= nil and #bunkerInput > 0 then
							local inputTable = bunkerInput[1];																				
							lineTable[#lineTable+1] = {};							
							isLineTable = lineTable[#lineTable];
							isLineTable.ownValues = {bunkersiloName};
							isLineTable.txt = {};			
							isLineTable.txt[1] = {};			
							isLineTable.txt[1].width = 80;	--width prozent
							isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor)
							isLineTable.txt[1].bold = moModule.values.txtBold;							
							if inputTable.fillTypesTotal ~= nil and #inputTable.fillTypesTotal > 1 then
								isLineTable.txt[1].txt = inputTable.fillTypeName.. " ++";
								isLineTable.txt[1].fillTypesTotal = inputTable.fillTypesTotal;
								isLineTable.txt[1].clickCallback = bunkersilos.returnClickFillTypesTotal;						
							else
								isLineTable.txt[1].txt = inputTable.fillTypeName;
							end;							
							isLineTable.txt[2] = {};			
							isLineTable.txt[2].width = 20;	--width prozent
							isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor)
							isLineTable.txt[2].bold = moModule.values.txtBold;
							isLineTable.txt[2].txt = inputTable.fillLevel;
							isLineTable.txt[2].txtPos = 2;
						end;						
					end;				
				end;							
			end;
		end;
	end;
	bunkersilos[bunkersiloName] = {output=lineTable};
end;

function bunkersilos.returnLineHelpIconClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.help.txt = tostring(bunkersilos[args.ownValues[1]].output[args.line].helpTxt);
		end;
	end;
end;

function bunkersilos.returnClickFillTypesTotal(...)
	if ... ~= nil then
		local args = ...;		
		if args.line ~= nil and args.position ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local fillTypesTotal = bunkersilos[args.ownValues[1]].output[args.line].txt[1].fillTypesTotal;
			local fillTypeNamen = "";			
			for _, fillType in pairs (fillTypesTotal) do				
				local fillTypes = moFillTypes.values.fillTypes[fillType];
				if fillTypes ~= nil then
					fillTypeNamen = fillTypeNamen.. tostring(fillTypes.name).. " - ";
				end;										
			end;			
			if string.len(fillTypeNamen) > 0 then
				moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
				moSetGetOverlays.infoHelpBox.info.txt = tostring(fillTypeNamen);	
			end;
		end;
	end;
end;

function bunkersilos.returnClickObjectName(...)
	if ... ~= nil then
		local args = ...;
		if args ~= nil and args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local bunkersiloName = args.ownValues[1];			
			if bunkersilos[bunkersiloName] ~= nil and bunkersilos[bunkersiloName].output ~= nil and bunkersilos[bunkersiloName].output[args.line] ~= nil then
				local nodeId = bunkersilos[bunkersiloName].output[args.line].txt[1].nodeId;
				local x, _, z = getWorldTranslation(nodeId);
				moSetGetOverlays:mapHotSpot(nil, x, z);	
			end;			
		end;		
	end;
end;

function bunkersilos.giveOutputTable(...)	
	if ... ~= nil then
		local args = ...;
		moModule.active.bunkersilos.isRunning = true;moModule.active.bunkersilos.last = moModule.time.min+moModule.time.delay;		
		if args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local bunkersiloName = args.ownValues[1];			
			bunkersilos:load(bunkersiloName);
			return bunkersilos[bunkersiloName].output;
		end;
	end;	
end;

function bunkersilos.reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	--bunkersilos:load();	
end;

function bunkersilos:generateCmd(bunkersiloName)
	local _, errorTable = 0, {};
	function insertCmd(bunkersiloName, objectsNodes, objectsIds)
		local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };	
		local bunkersiloNameTemp = tostring(bunkersiloName):lower();
		local languageName = moLanguageXml:getTxt(bunkersiloNameTemp, nil, bunkersiloName);
		newCmdTable.cmdTable[1] = {
			cmdName = "bunkersilos_".. bunkersiloName;			
			displayName = moLanguageXml:getTxt("bunkersilos", nil, "BunkerSilos").. " ".. tostring(languageName);	
			multiple = true;
			sortBy = "BunkerSilos";
			infoTxt = "Zeigt alle BunkerSilos an (".. tostring(languageName).. ")";
			helpTxt = "View all Bunkersilos (".. tostring(bunkersiloName).. ")";
			click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
			objectId = {};			
			lineTyp = 2;
			typ = "output";
			action = bunkersilos.giveOutputTable; --a function
			ownValues = {bunkersiloName, objectsNodes, objectsIds}; 
		};		
		_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);
		local errorPrint = false;
		if errorPrint and #errorTable > 0 then
			for a=1, #errorTable do
				print("! ERROR ! MultiOverlayV3 Hud -->cmd generate bunkersilos ".. tostring(bunkersiloName).. " Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
			end;
		end;
	end;
	if bunkersiloName ~= nil then 
		local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "bunkersilos_".. bunkersiloName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
		--local objectId = moSetGetExtras:getNodeObject(object, false);
		if isAlreadyExits == nil then insertCmd(bunkersiloName, objectId);end;
	else
		if moBunkerSilos.values.bunkersilos ~= nil then
			for bunkersiloName, _ in pairs (moBunkerSilos.values.bunkersilos) do
				local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "bunkersilos_".. bunkersiloName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
				if isAlreadyExits == nil then insertCmd(bunkersiloName, moModule:getObjectIds(moBunkerSilos.values.bunkersilos[bunkersiloName], false));end;
			end;
		end;
	end;	
end;		